#!*****************************************************************************
#!*****************************************************************************
#TEMPLATE(ShurOpenClose,'Shur''s Table Open/Close Template'),FAMILY('ABC','Clarion')
#!*****************************************************************************
#!*****************************************************************************
#EXTENSION(ShurOpenCloseGlobal,'Shur''s Table Open/Close Generation'),APPLICATION
#BOXED('Shur''s Open/Close Template')
  #DISPLAY ('This template counts table''s open/close operations.')
  #DISPLAY ('http://www.shursoft.com    info@shursoft.com')
  #PROMPT('Enable Open/Close Tamplate',CHECK),%ShurOpenCloseEnable,DEFAULT(%True),AT(10,30)
  #PROMPT('Disable warning if table is used in schema',CHECK),%ShurOpenCloseWarningDisabled,DEFAULT(%False),AT(10,45)
  #DISPLAY (' more than once'),AT(20,55)
#ENDBOXED
#!*****************************************************************************
#!------------------------------------------------------------------------------------------------------------------------------
#AT(%GlobalData)
   #IF(%ShurOpenCloseEnable)
shTableQueue QUEUE,PRE(shTabQ) #<! ShurOpenClose: declare the queue
Table                   CSTRING(128)
Cnt                      LONG
                      END
   #ENDIF
#ENDAT
#!*****************************************************************************
#AT(%AfterFileOpen) 
   #IF(%ShurOpenCloseEnable)
      #FOR(%File), WHERE(%FileIsUsed())
          #IF(%FileThreaded<>1) 
   shTabQ:Table = '%File'; GET(shTableQueue,+shTabQ:Table); if errorcode() then shTabQ:Cnt = 1; add(shTableQueue) else shTabQ:Cnt += 1; put(shTableQueue) end; if shTabQ:Cnt = 0 then delete(shTableQueue) end #<! ShurOpenClose: Non-threaded file
          #ENDIF
      #ENDFOR
   #ENDIF
#ENDAT
#!*****************************************************************************
#AT(%AfterFileClose) 
   #IF(%ShurOpenCloseEnable)
      #FOR(%File), WHERE(%FileIsUsed())
          #IF(%FileThreaded<>1) 
   shTabQ:Table = '%File'; GET(shTableQueue,+shTabQ:Table); if errorcode() then shTabQ:Cnt = -1; add(shTableQueue) else shTabQ:Cnt -= 1; put(shTableQueue) end; if shTabQ:Cnt = 0 then delete(shTableQueue) end #<! ShurOpenClose: Non-threaded file
          #ENDIF
      #ENDFOR
   #ENDIF
#ENDAT
#!*****************************************************************************
#AT(%AfterFileOpen),PRIORITY(1),DESCRIPTION('ShurOpenClose'),AUTO 
   #IF(%ShurOpenCloseEnable)
      #DECLARE(%PreviouslyOpenedFiles),MULTI,UNIQUE
      #DECLARE(%ErrorSymbol)
      #IF(%ProcedureTemplate<>'ToDo')
         #FOR(%ActiveTemplate)
            #FOR(%ActiveTemplateInstance)
               #IF(NOT %Primary OR INSTRING('BUTTON',UPPER(%ActiveTemplate),1,1))
                  #CYCLE
               #ENDIF
               #CALL(%ConstructOpenList)
            #ENDFOR
         #ENDFOR
      #ENDIF
      #FOR(%OtherFiles)
         #FIX(%File,%OtherFiles)
         #CALL(%OpenTableGroup,'Other file')
      #ENDFOR
   #ENDIF
#ENDAT
#!*****************************************************************************
#AT(%AfterFileClose),PRIORITY(1),DESCRIPTION('ShurOpenClose'),AUTO 
   #IF(%ShurOpenCloseEnable)
      #DECLARE(%PreviouslyOpenedFiles),MULTI,UNIQUE
      #DECLARE(%ErrorSymbol)
      #IF(%ProcedureTemplate<>'ToDo')
         #FOR(%ActiveTemplate)
            #FOR(%ActiveTemplateInstance)
               #IF(NOT %Primary OR INSTRING('BUTTON',UPPER(%ActiveTemplate),1,1))
                  #CYCLE
               #ENDIF
               #CALL(%ConstructCloseList)
            #ENDFOR
         #ENDFOR
      #ENDIF
      #FOR(%OtherFiles)
         #FIX(%File,%OtherFiles)
         #CALL(%CloseTableGroup,'Other file')
      #ENDFOR
   #ENDIF
#ENDAT
#!*****************************************************************************
#GROUP(%ConstructOpenList)
#!%ActiveTemplate:%ActiveTemplateInstance
#FIX(%File,%Primary)
#!%File (Primary)
   #CALL(%OpenTableGroup,'Primary file')
   #CALL(%ConstructSecondariesOpenList, %Primary)
#!*****************************************************************************
#GROUP(%ConstructCloseList)
#!%ActiveTemplate:%ActiveTemplateInstance
#FIX(%File,%Primary)
#!%File (Primary)
   #CALL(%CloseTableGroup,'Primary file')
   #CALL(%ConstructSecondariesCloseList, %Primary)
#!*****************************************************************************
#GROUP(%ConstructSecondariesOpenList, %To)
#FOR(%Secondary),WHERE(%SecondaryTo = %To)
  #FIX(%File,%Secondary)
#!%File (Secondary)
  #FIX(%Relation,%To)
   #CALL(%OpenTableGroup,'Secondary file')
   #CALL(%ConstructSecondariesOpenList, %File)
#ENDFOR
#!*****************************************************************************
#GROUP(%ConstructSecondariesCloseList, %To)
#FOR(%Secondary),WHERE(%SecondaryTo = %To)
  #FIX(%File,%Secondary)
#!%File (Secondary)
  #FIX(%Relation,%To)
   #CALL(%CloseTableGroup,'Secondary file')
   #CALL(%ConstructSecondariesCloseList, %File)
#ENDFOR
#!*****************************************************************************
#GROUP(%OpenTableGroup,%Comment)
#IF (~INLIST(%File, %PreviouslyOpenedFiles))
   #IF(%FileThreaded=1) 
shTabQ:Table = '%File'; GET(shTableQueue,+shTabQ:Table); if errorcode() then shTabQ:Cnt = 1; add(shTableQueue) else shTabQ:Cnt += 1; put(shTableQueue) end; if shTabQ:Cnt = 0 then delete(shTableQueue) end #<! ShurOpenClose: %Comment
        #ADD(%PreviouslyOpenedFiles, %File)
   #ENDIF
#ELSIF(~%ShurOpenCloseWarningDisabled)
   #SET(%ErrorSymbol,('WARNING: (ShurOpenClose) Procedure ' & %Procedure & ' uses table ' & %File & ' in the schema more than once'))
   #ERROR(%ErrorSymbol)
#ENDIF
#!*****************************************************************************
#GROUP(%CloseTableGroup,%Comment)
#IF (~INLIST(%File, %PreviouslyOpenedFiles))
   #IF(%FileThreaded=1) 
shTabQ:Table = '%File'; GET(shTableQueue,+shTabQ:Table); if errorcode() then shTabQ:Cnt = -1; add(shTableQueue) else shTabQ:Cnt -= 1; put(shTableQueue) end; if shTabQ:Cnt = 0 then delete(shTableQueue) end #<! ShurOpenClose: %Comment
        #ADD(%PreviouslyOpenedFiles, %File)
   #ENDIF
#ELSIF(~%ShurOpenCloseWarningDisabled)
   #SET(%ErrorSymbol,('WARNING: (ShurOpenClose) Procedure ' & %Procedure & ' uses table ' & %File & ' in the schema more than once'))
   #ERROR(%ErrorSymbol)
#ENDIF
#!*****************************************************************************
#GROUP(%FileIsUsed)
#IF(%OverrideGenerate)
  #RETURN(%True)
#ELSE
  #IF(%DefaultGenerate)
    #RETURN(%True)
  #ELSE
    #IF(INLIST(%File,%UsedFile))
      #RETURN(%True)
    #ENDIF
  #ENDIF
#END
#RETURN(%False)
